Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.crosswire.common.util
Class EventListenerList

    java.lang.Object
      org.crosswire.common.util.EventListenerList

All Implemented Interfaces:
  Serializable

    public class EventListenerList

extends Object
implements Serializable

A class which holds a list of EventListeners. This code is lifted from javax.sw*ng.event.EventListnerList. It is very useful in non GUI code which does not need the rest of sw*ng. BORROWED: From javax.sw*ng.event.EventListnerList

If you inculde sw*ng code in non-gui code then you can end up not being able to run your code in a headerless environment because X includes Y which inculdes Font which tries to lookup font metrics and then everything dies. I appreciate the Headerless changes in 1.4 , but my rule (from before 1.4) was "Don't inculde swing code from non-swing code", and I enforced that by making sure all my swing code was in a package with swing in the name and by making sure that the word swing was not in any non-swing code (hence I spelled it sw*ng in comments) That way some simple greps will tell you if the servlet front end was likely to die.

A single instance can be used to hold all listeners (of all types) for the instance using the lsit. It is the responsiblity of the class using the EventListenerList to provide type-safe API (preferably conforming to the JavaBeans spec) and methods which dispatch event notification methods to appropriate Event Listeners on the list. The main benefits which this class provides are that it is relatively cheap in the case of no listeners, and provides serialization for eventlistener lists in a single place, as well as a degree of MT safety (when used correctly). Usage example: Say one is defining a class which sends out FooEvents, and wantds to allow users of the class to register FooListeners and receive notification when FooEvents occur. The following should be added to the class definition:

       EventListenerList listenrList = new EventListnerList();
       FooEvent fooEvent = null;

       public void addFooListener(FooListener l) {
           listenerList.add(FooListener.class, l);
       }

       public void removeFooListener(FooListener l) {
           listenerList.remove(FooListener.class, l);
       }

        // Notify all listeners that have registered interest for
        // notification on this event type.  The event instance
        // is lazily created using the parameters passed into
        // the fire method.

        protected void firefooXXX() {
        // Guaranteed to return a non-null array
        Object[] listeners = listenerList.getListenerList();
        // Process the listeners last to first, notifying
        // those that are interested in this event
        for (int i = listeners.length-2; i>=0; i-=2) {
            if (listeners[i]==FooListener.class) {
            // Lazily create the event:
            if (fooEvent == null)
                fooEvent = new FooEvent(this);
            ((FooListener)listeners[i+1]).fooXXX(fooEvent);
            }
        }
        }

foo should be changed to the appropriate name, and Method to the appropriate method name (one fire method should exist for each notification method in the FooListener interface).

Warning: Serialized objects of this class will not be compatible with future Sw*ng releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Sw*ng. A future release of Sw*ng will provide support for long term persistence.

Version:
  1.23 10/01/98
Author:
  Georges Saab, Hans Muller, James Gosling
See Also:
  Serialized Form

Field Summary
`protected Object[]` | `listenerList` The list of ListenerType - Listener pairs
`private static Object[]` | `NULL_ARRAY` A null array to be shared by all empty listener lists
`private static long` | `serialVersionUID` Serialization ID

Constructor Summary
`EventListenerList()`

Method Summary
`void` | `add(Class t, EventListener li)` Add the listener as a listener of the specified type.
`Object[]` | `getListenerList()` This passes back the event listener list as an array of ListenerType - listener pairs.
`private void` | `readObject(ObjectInputStream ois)` Serialization support
`void` | `remove(Class t, EventListener li)` Remove the listener as a listener of the specified type.
`String` | `toString()` Return a string representation of the EventListenerList.
`private void` | `writeObject(ObjectOutputStream oos)` Serialization support

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### NULL_ARRAY

    private static final Object[] NULL_ARRAY

  A null array to be shared by all empty listener lists

### listenerList

    protected transient Object[] listenerList

  The list of ListenerType - Listener pairs

### serialVersionUID

    private static final long serialVersionUID

  Serialization ID

  See Also:
    Constant Field Values

Constructor Detail

### EventListenerList

    public EventListenerList()

Method Detail

### getListenerList

    public Object[] getListenerList()

  This passes back the event listener list as an array of ListenerType - listener pairs. Note that for performance reasons, this implementation passes back the actual data structure in which the listner data is stored internally! This method is guaranteed to pass back a non-null array, so that no null-checking is required in fire methods. A zero-length array of Object should be returned if there are currently no listeners. WARNING!!! Absolutely NO modification of the data contained in this array should be made -- if any such manipulation is necessary, it should be done on a copy of the array returned rather than the array itself.

### add

    public void add(Class t,
                    EventListener li)

  Add the listener as a listener of the specified type.

  Parameters:
    `t` - the type of the listener to be added
    `li` - the listener to be added

### remove

    public void remove(Class t,
                       EventListener li)

  Remove the listener as a listener of the specified type.

  Parameters:
    `t` - the type of the listener to be removed
    `li` - the listener to be removed

### writeObject

    private void writeObject(ObjectOutputStream oos)
                      throws IOException

  Serialization support

  Throws:
    `IOException`

### readObject

    private void readObject(ObjectInputStream ois)
                     throws IOException,
                            ClassNotFoundException

  Serialization support

  Throws:
    `IOException`
    `ClassNotFoundException`

### toString

    public String toString()

  Return a string representation of the EventListenerList.

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Copyright ? 2003-2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD